

require ('queuemon')
require ('llp')
local function trace(a,b,c,d) return end

function main(Msg)
   
   local secondChannel= 'load balance 2' -- <your second channel name>
   local firstChannel = 'load balance 1' -- <your first channel name>
   local count = 3
   -- Setting the channel name and count explicitly
   local QC = queuemon.checkQueue{channel = firstChannel, count = count}  
   
   if QC then 
      send2Channel(secondChannel,Msg) -- use it to send to channel on remote machine
      push2queue(secondChannel,Msg)   -- use it to push to queue for channel on this machine
   else 
      push2queue(firstChannel,Msg)   -- use it to push to queue for channel on this machine
   end
   
end


function push2queue(channel,msg)
   --[[ use example from Wiki to see how we 
   serialize as JSON object; and in target channels source 
   component 'From Translator' filter messages by value 
   of first field in JSON object, respectively.
   
   if JSON objects 1st field has index/name of *this* channel 
   - then process this message, else ignore this message by 
   immediately executing 'return' in function main() of 
   target channel.
   ]]
   
   local q= toJSON(channel,msg)
   queue.push{data = q}
   iguana.logDebug(channel..' > '..msg)
end


function toJSON(channel,msg)
   local F = {}
   F.a1 = channel
   F.b1 = msg
   return json.serialize{data=F}
end


function send2Channel(channel,msg)
   --[[ use example from Wiki how to use 
   Translator as LLP Client in order 
   to send msg to IP and port of 
   channel 1 or channel 2 respectively.
   
   If you use IP=127.0.0.1 (i.e. localhost)
   then msg will be sent to another channel 
   on same (source) machine. 
   
   Please note that even if you have more 
   than one Iguana instance on a machine, 
   msg will be sent to channel respective 
   to specified port value of listening 
   channel.
   ]]
   iguana.logDebug(channel..' > '..msg)
end

